## busybox 1

=== debian/changelog ===
busybox (1:1-1+eagle) unstable; urgency=medium

  * update

 -- Debian Install System Team <debian-boot@lists.debian.org>  Tue, 10 May 2022 20:30:41 +0800

busybox (1:1.30.1.3-1+dde) unstable; urgency=medium

  * fix CVE-2022-28391.
  * 

 -- xinpeng wang <wangxinpeng@uniontech.com>  Thu, 05 May 2022 16:30:08 +0800

busybox (1:1.30.1.2-1+dde) unstable; urgency=medium

  * Non-maintainer upload.
  * fix CVE-2021-28831

 -- liujianqiang <liujianqiang@uniontech.com>  Fri, 11 Jun 2021 10:09:06 +0800

busybox (1:1.30.1.1-1+dde) stable; urgency=medium

  * add sw64 porting

 -- zhangfeilong <zhangfeilong@uniontech.com>  Thu, 15 Apr 2021 00:25:39 +0800

busybox (1:1.30.1-4+dde) unstable; urgency=high

  [ Ben Hutchings ]
  * Drop "Stop overriding stack alignment on i386" as this behaviour is now
    configurable
  * debian/rules: Enable verbose output (V=1) for "make oldconfig"

  [ Cyril Brulebois ]
  * Reinstate temp-deb-installer-hack.patch and FEATURE_DI_ENV_HACK=y
    Closes: #925979

 -- Christoph Biedl <debian.axhn@manchmal.in-ulm.de>  Mon, 01 Apr 2019 07:17:50 +0200

busybox (1:1.30.1-3) unstable; urgency=high

  * Ignore any valid_lft or preferred_lft parameters to ip, thanks 
    Steve Langasek. Closes: #924442
  * Fix ip oneline, thanks Dominik George. Closes: #924374

 -- Christoph Biedl <debian.axhn@manchmal.in-ulm.de>  Sun, 24 Mar 2019 16:52:05 +0100

busybox (1:1.30.1-2) unstable; urgency=high

  * Complete the fix for [CVE-2018-20679] Closes: #918846

 -- Christoph Biedl <debian.axhn@manchmal.in-ulm.de>  Sat, 02 Mar 2019 09:11:13 +0100

busybox (1:1.30.1-1) unstable; urgency=high

  [ Christoph Biedl ]
  * New upstream version 1.30.1
    Closes: #918846 [CVE-2018-20679]
  * Refresh patch queue
  * Update busybox configurations for new upstream version

  * Debian packaging changes:
    [ Chris Boot ]
    * Check signatures on upstream tarballs:
      - d/watch: set opts=pgpsigurlmangle
      - d/upstream/signing-key.asc: import Denis Vlasenko's key
    * d/changelog:
      - Correct CVE reference in changelog entry for previous upload.
      - Remove trailing whitespace.
    * d/rules:
      - Remove trailing whitespace.
    * Switch to debhelper 11.
    * d/control:
      - Set Rules-Requires-Root: no.
      - Bump Standards-Version to 4.1.5; no other changes required.
    * Remove obsolete files:
      - d/bin/genorig.py: not needed since ~2008.
      - d/udeb-sizes: not updated since ~2012.
    [ Christoph Biedl ]
    * Add a README for any package maintainer

  [ Chris Boot ]
  * Refresh and rework patches:
    - Drop patches cherry-picked from upstream.
    - Drop temp-deb-installer-hack.patch: no longer needed.
    - Rework patches to account for upstream changes:
      - shell-ash-export-HOME.patch
      - version.patch
  * Enable new applets for use by initramfs-tools: nuke, resume, run-init.

 -- Christoph Biedl <debian.axhn@manchmal.in-ulm.de>  Fri, 01 Mar 2019 21:19:43 +0100

busybox (1:1.27.2-3) unstable; urgency=medium

  [ Cyril Brulebois ]
  * Update Vcs-{Browser,Git} to point to salsa (alioth's replacement).

  [ Chris Lamb ]
  * PEP8 fixes.

  [ Ben Hutchings ]
  * Stop overriding stack alignment on i386 (Closes: #886506)
  * Apply security fixes for wget from upstream:
    - wget: more thorough sanitization of other side's data
    - wget: check chunk length for overflowing off_t (CVE-2018-1000517)
      (Closes: #902724)
    - wget: handle URLs with @ or hash differently

 -- Ben Hutchings <ben@decadent.org.uk>  Fri, 13 Jul 2018 04:19:08 +0100

busybox (1:1.27.2-2) unstable; urgency=medium

  * Trigger an initramfs rebuild on installation. (Closes: #549022)
  * Temporarily re-enable invalid variable names in the udeb flavour for
    debian-installer.
  * Install the readlink binary in /bin. (Closes: #801850)
  * Fix integer overflow in bzip2 decompresson [CVE-2017-15873].
    (Closes: #879732)
  * Fix integer underflow in LZMA decompressor [CVE-2017-15874].
    (Closes: #879732)
  * Prevent tab completion for strings containing control characters
    [CVE-2017-16544].
  * Debian packaging changes:
    - Update debian/control:
      - Update Standards-Version to 4.1.1.
      - Change Priority to optional for all packages.
    - Remove obsolete debian/gbp.conf.
    - Update debian/watch:
      - Switch to format=4.
      - Use HTTPS URI.

 -- Chris Boot <bootc@debian.org>  Tue, 28 Nov 2017 13:45:04 +0000

busybox (1:1.27.2-1) unstable; urgency=medium

  * New upstream release. This addresses:
    - Segmentation fault when creating compressed tar files. (Closes: #812074)
    - Pointer misuse unziping files. (Closes: #803097)
    - Buffer overflow in the DHCP client [CVE-2016-2148]. (Closes: #818497)
    - Integer overflow in the DHCP client [CVE-2016-2147]. (Closes: #818499)
  * Postpone creation of symlinks with "suspicious" targets [CVE-2011-5325].
    (Closes: #802702)
  * Re-enable the test suite during build. (Closes: #794526)
  * udhcpc: correct a typo in /etc/udhcpc/default.script. (Closes: #873472)
  * Debian packaging changes:
    - Run wrap-and-sort -st.
    - Update debian/control:
      - Replace Uploaders with myself and Christoph Biedl. Many thanks to
        Bastian Blank and Michael Tokarev for having maintained busybox for
        many years prior.
      - Remove Build-Depends to avoid ancient broken libc-dev-bin.
      - Bump Build-Depends on debhelper to >= 10.
    - Rewrite debian/rules:
      - Simplify and use the dh sequencer.
      - Remove test for ancient broken libc6 versions with static binaries.
      - Strip -O2 from CFLAGS, falling back to -Os from the busybox
        configuration.
      - Abort the build if 'make oldconfig' changes the configuration at all.
    - Update busybox build configuration files for the new upstream release.
      - The udeb configuration mostly hasn't changed, but enable fgrep,
        blkdiscard, bzcat and lsscsi.
      - The deb and static configurations have had upstream recommendations


## busybox 1.1.3

=== applets/Makefile ===
# Makefile for busybox
#
# Copyright (C) 1999-2005 by Erik Andersen <andersen@codepoet.org>
#
# Licensed under the GPL v2, see the file LICENSE in this tarball.

ifndef top_srcdir
top_srcdir=..
endif
ifndef top_builddir
top_builddir=..
endif
srcdir=$(top_srcdir)/applets
APPLETS_DIR:=./
include $(top_builddir)/Rules.mak
include $(top_builddir)/.config
include $(srcdir)/Makefile.in
all: $(libraries-y)
-include $(top_builddir).depend

clean:
	rm -f *.o *.a $(AR_TARGET)

=== archival/Makefile ===
# Makefile for busybox
#
# Copyright (C) 1999-2005 by Erik Andersen <andersen@codepoet.org>
#
# Licensed under the GPL v2, see the file LICENSE in this tarball.

ifndef top_srcdir
top_srcdir=..
endif
ifndef top_builddir
top_builddir=..
endif
ARCHIVAL_DIR:=./
srcdir=$(top_srcdir)/archival
include $(top_builddir)/Rules.mak
include $(top_builddir)/.config
include $(srcdir)/Makefile.in
all: $(libraries-y)
-include $(top_builddir)/.depend

clean:
	rm -f *.o *.a $(AR_TARGET)

=== console-tools/Makefile ===
# Makefile for busybox
#
# Copyright (C) 1999-2005 by Erik Andersen <andersen@codepoet.org>
#
# Licensed under the GPL v2, see the file LICENSE in this tarball.

ifndef top_srcdir
top_srcdir=..
endif
ifndef top_builddir
top_builddir=..
endif
srcdir=$(top_srcdir)/console/tools
CONSOLETOOLS_DIR:=./
include $(top_builddir)/Rules.mak
include $(top_builddir)/.config
include $(srcdir)/Makefile.in
all: $(libraries-y)
-include $(top_builddir)/.depend

clean:
	rm -f *.o *.a $(AR_TARGET)

=== debianutils/Makefile ===
# Makefile for busybox
#
# Copyright (C) 1999-2005 by Erik Andersen <andersen@codepoet.org>
#
# Licensed under the GPL v2, see the file LICENSE in this tarball.

ifndef top_srcdir
top_srcdir=..
endif
ifndef top_builddir
top_builddir=..
endif
srcdir=$(top_srcdir)/debianutils
DEBIANUTILS_DIR:=./
include $(top_builddir)/Rules.mak
include $(top_builddir)/.config
include $(srcdir)/Makefile.in
all: $(libraries-y)
-include $(top_builddir)/.depend

clean:
	rm -f *.o *.a $(AR_TARGET)

=== e2fsprogs/Makefile ===
# Makefile for busybox
#
# Copyright (C) 1999-2005 by Erik Andersen <andersen@codepoet.org>
#
# Licensed under the GPL v2, see the file LICENSE in this tarball.

ifndef top_srcdir
top_srcdir=..
endif
ifndef top_builddir
top_builddir=..
endif
srcdir=$(top_srcdir)/e2fsprogs
E2FSPROGS_DIR:=./
include $(top_builddir)/.config
include $(top_builddir)/Rules.mak
include Makefile.in
all: $(libraries-y)
-include $(top_builddir)/.depend

clean:
	rm -f *.o *.a */*.o $(AR_TARGET)

=== findutils/Makefile ===
# Makefile for busybox
#
# Copyright (C) 1999-2005 by Erik Andersen <andersen@codepoet.org>
#
# Licensed under the GPL v2, see the file LICENSE in this tarball.

ifndef top_srcdir
top_srcdir=..
endif
ifndef top_builddir
top_builddir=..
endif
srcdir=$(top_srcdir)/findutils
FINDUTILS_DIR:=./
include $(top_builddir)/Rules.mak
include $(top_builddir)/.config
include $(srcdir)/Makefile.in
all: $(libraries-y)
-include $(top_builddir)/.depend

clean:
	rm -f *.o *.a $(AR_TARGET)

=== init/Makefile ===
# Makefile for busybox
#
# Copyright (C) 1999-2005 by Erik Andersen <andersen@codepoet.org>
#
# Licensed under the GPL v2, see the file LICENSE in this tarball.

ifndef top_srcdir
top_srcdir=..
endif
ifndef top_builddir
top_builddir=..
endif
srcdir=$(top_srcdir)/init
INIT_DIR:=./
include $(top_builddir)/Rules.mak
include $(top_builddir)/.config
include $(srcdir)/Makefile.in
all: $(libraries-y)
-include $(top_builddir)/.depend

clean:
	rm -f *.o *.a $(AR_TARGET)

=== libpwdgrp/Makefile ===
# Makefile for busybox
#
# Copyright (C) 1999-2005 by Erik Andersen <andersen@codepoet.org>
#
# Licensed under the GPL v2, see the file LICENSE in this tarball.

ifndef top_srcdir
top_srcdir=..
endif
ifndef top_builddir
top_builddir=..
endif
srcdir=$(top_srcdir)/libpwgrp
LIBPWDGRP_DIR:=./
include $(top_builddir)/Rules.mak
include $(top_builddir)/.config
include Makefile.in
all: $(libraries-y)
-include $(top_builddir)/.depend

clean:
	rm -f *.o *.a $(AR_TARGET)

=== modutils/Makefile ===
# Makefile for busybox
#
# Copyright (C) 1999-2005 by Erik Andersen <andersen@codepoet.org>
#
# Licensed under the GPL v2, see the file LICENSE in this tarball.

ifndef top_srcdir
top_srcdir=..
endif
ifndef top_builddir
top_builddir=..
endif
srcdir=$(top_srcdir)/modutils
MODUTILS_DIR:=./
include $(top_builddir)/Rules.mak
include $(top_builddir)/.config
include Makefile.in
all: $(libraries-y)
-include $(top_builddir)/.depend

clean:
	rm -f *.o *.a $(AR_TARGET)

=== networking/Makefile ===
# Makefile for busybox
#
# Copyright (C) 1999-2005 by Erik Andersen <andersen@codepoet.org>
#
# Licensed under the GPL v2, see the file LICENSE in this tarball.

ifndef top_srcdir
top_srcdir=..
endif
ifndef top_builddir
top_builddir=..
endif
srcdir=$(top_srcdir)/networking
NETWORKING_DIR:=./
include $(top_builddir)/Rules.mak
include $(top_builddir)/.config
include Makefile.in
all: $(libraries-y)
-include $(top_builddir)/.depend

clean:
	rm -f *.o *.a $(AR_TARGET)

=== procps/Makefile ===
# Makefile for busybox
#
# Copyright (C) 1999-2005 by Erik Andersen <andersen@codepoet.org>
#
# Licensed under the GPL v2, see the file LICENSE in this tarball.

ifndef top_srcdir
top_srcdir=..
endif
ifndef top_builddir
top_builddir=..
endif
srcdir=$(top_srcdir)/procps
PROCPS_DIR:=./
include $(top_builddir)/Rules.mak
include $(top_builddir)/.config
include Makefile.in
all: $(libraries-y)
-include $(top_builddir)/.depend

clean:
	rm -f *.o *.a $(AR_TARGET)

=== archival/libunarchive/Makefile ===
# Makefile for busybox
#
# Copyright (C) 1999-2004 by Erik Andersen <andersen@codepoet.org>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
#

ifndef top_srcdir
top_srcdir=../..
endif
ifndef top_builddir
top_builddir=../..
endif
srcdir=$(top_srcdir)/archival/libunarchive
LIBUNARCHIVE_DIR:=./
include $(top_builddir)/Rules.mak
include $(top_builddir)/.config
include $(srcdir)/Makefile.in
all: $(libraries-y)
-include $(top_builddir)/.depend

clean:
	rm -f *.o *.a $(AR_TARGET)

## busybox 1.4.1

=== Makefile ===
VERSION = 1
PATCHLEVEL = 4
SUBLEVEL = 1
EXTRAVERSION =
NAME = Unnamed

# *DOCUMENTATION*
# To see a list of typical targets execute "make help"
# More info can be located in ./README
# Comments in this file are targeted only to the developer, do not
# expect to learn how to build the kernel reading this file.

# Do not print "Entering directory ..."
MAKEFLAGS += --no-print-directory

# We are using a recursive build, so we need to do a little thinking
# to get the ordering right.
#
# Most importantly: sub-Makefiles should only ever modify files in
# their own directory. If in some directory we have a dependency on
# a file in another dir (which doesn't happen often, but it's often
# unavoidable when linking the built-in.o targets which finally
# turn into busybox), we will call a sub make in that other dir, and
# after that we are sure that everything which is in that other dir
# is now up to date.
#
# The only cases where we need to modify files which have global
# effects are thus separated out and done before the recursive
# descending is started. They are now explicitly listed as the
# prepare rule.

# To put more focus on warnings, be less verbose as default
# Use 'make V=1' to see the full commands

ifdef V
  ifeq ("$(origin V)", "command line")
    KBUILD_VERBOSE = $(V)
  endif
endif
ifndef KBUILD_VERBOSE
  KBUILD_VERBOSE = 0
endif

# Call sparse as part of compilation of C files
# Use 'make C=1' to enable sparse checking

ifdef C
  ifeq ("$(origin C)", "command line")
    KBUILD_CHECKSRC = $(C)
  endif
endif
ifndef KBUILD_CHECKSRC
  KBUILD_CHECKSRC = 0
endif

# Use make M=dir to specify directory of external module to build
# Old syntax make ... SUBDIRS=$PWD is still supported
# Setting the environment variable KBUILD_EXTMOD take precedence
ifdef SUBDIRS
  KBUILD_EXTMOD ?= $(SUBDIRS)
endif
ifdef M
  ifeq ("$(origin M)", "command line")
    KBUILD_EXTMOD := $(M)
  endif
endif


# kbuild supports saving output files in a separate directory.
# To locate output files in a separate directory two syntaxes are supported.
# In both cases the working directory must be the root of the kernel src.
# 1) O=
# Use "make O=dir/to/store/output/files/"
#
# 2) Set KBUILD_OUTPUT
# Set the environment variable KBUILD_OUTPUT to point to the directory
# where the output files shall be placed.
# export KBUILD_OUTPUT=dir/to/store/output/files/
# make
#
# The O= assignment takes precedence over the KBUILD_OUTPUT environment
# variable.


# KBUILD_SRC is set on invocation of make in OBJ directory
# KBUILD_SRC is not intended to be used by the regular user (for now)
ifeq ($(KBUILD_SRC),)

# OK, Make called in directory where kernel src resides
# Do we want to locate output files in a separate directory?
ifdef O
  ifeq ("$(origin O)", "command line")
    KBUILD_OUTPUT := $(O)
  endif
endif

# That's our default target when none is given on the command line
PHONY := _all
_all:

ifneq ($(KBUILD_OUTPUT),)
# Invoke a second make in the output directory, passing relevant variables
# check that the output directory actually exists
saved-output := $(KBUILD_OUTPUT)
KBUILD_OUTPUT := $(shell cd $(KBUILD_OUTPUT) && /bin/pwd)
$(if $(KBUILD_OUTPUT),, \
     $(error output directory "$(saved-output)" does not exist))

PHONY += $(MAKECMDGOALS)

$(filter-out _all,$(MAKECMDGOALS)) _all:
	$(if $(KBUILD_VERBOSE:1=),@)$(MAKE) -C $(KBUILD_OUTPUT) \
	KBUILD_SRC=$(CURDIR) \
	KBUILD_EXTMOD="$(KBUILD_EXTMOD)" -f $(CURDIR)/Makefile $@

# Leave processing to above invocation of make
skip-makefile := 1
endif # ifneq ($(KBUILD_OUTPUT),)
endif # ifeq ($(KBUILD_SRC),)

# We process the rest of the Makefile if this is the final invocation of make
ifeq ($(skip-makefile),)

# If building an external module we do not care about the all: rule
# but instead _all depend on modules
PHONY += all
ifeq ($(KBUILD_EXTMOD),)
_all: all
else
_all: modules
endif

srctree		:= $(if $(KBUILD_SRC),$(KBUILD_SRC),$(CURDIR))
TOPDIR		:= $(srctree)
# FIXME - TOPDIR is obsolete, use srctree/objtree
objtree		:= $(CURDIR)
src		:= $(srctree)
obj		:= $(objtree)

VPATH		:= $(srctree)$(if $(KBUILD_EXTMOD),:$(KBUILD_EXTMOD))

export srctree objtree VPATH TOPDIR


# SUBARCH tells the usermode build what the underlying arch is.  That is set
# first, and if a usermode build is happening, the "ARCH=um" on the command
# line overrides the setting of ARCH below.  If a native build is happening,
# then ARCH is assigned, getting whatever value it gets normally, and
# SUBARCH is subsequently ignored.

SUBARCH := $(shell uname -m | sed -e s/i.86/i386/ -e s/sun4u/sparc64/ \
				  -e s/arm.*/arm/ -e s/sa110/arm/ \
				  -e s/s390x/s390/ -e s/parisc64/parisc/ \
				  -e s/ppc.*/powerpc/ -e s/mips.*/mips/ )

# Cross compiling and selecting different set of gcc/bin-utils
# ---------------------------------------------------------------------------
#
# When performing cross compilation for other architectures ARCH shall be set
# to the target architecture. (See arch/* for the possibilities).
# ARCH can be set during invocation of make:
# make ARCH=ia64
# Another way is to have ARCH set in the environment.
# The default ARCH is the host where make is executed.

# CROSS_COMPILE specify the prefix used for all executables used
# during compilation. Only gcc and related bin-utils executables
# are prefixed with $(CROSS_COMPILE).
# CROSS_COMPILE can be set on the command line
# make CROSS_COMPILE=ia64-linux-
# Alternatively CROSS_COMPILE can be set in the environment.
# Default value for CROSS_COMPILE is not to prefix executables
# Note: Some architectures assign CROSS_COMPILE in their arch/*/Makefile

ARCH		?= $(SUBARCH)
CROSS_COMPILE	?=

# Architecture as present in compile.h
UTS_MACHINE := $(ARCH)

# SHELL used by kbuild
CONFIG_SHELL := $(shell if [ -x "$$BASH" ]; then echo $$BASH; \
	  else if [ -x /bin/bash ]; then echo /bin/bash; \
	  else echo sh; fi ; fi)

HOSTCC  	= gcc
HOSTCXX  	= g++
HOSTCFLAGS	= -Wall -Wstrict-prototypes -O2 -fomit-frame-pointer
HOSTCXXFLAGS	= -O2

# 	Decide whether to build built-in, modular, or both.
#	Normally, just do built-in.

KBUILD_MODULES :=
KBUILD_BUILTIN := 1

#	If we have only "make modules", don't compile built-in objects.
#	When we're building modules with modversions, we need to consider
#	the built-in objects during the descend as well, in order to
#	make sure the checksums are uptodate before we record them.

ifeq ($(MAKECMDGOALS),modules)
  KBUILD_BUILTIN := $(if $(CONFIG_MODVERSIONS),1)
endif

#	If we have "make <whatever> modules", compile modules
#	in addition to whatever we do anyway.
#	Just "make" or "make all" shall build modules as well

ifneq ($(filter all _all modules,$(MAKECMDGOALS)),)
  KBUILD_MODULES := 1
endif

ifeq ($(MAKECMDGOALS),)
  KBUILD_MODULES := 1
endif

export KBUILD_MODULES KBUILD_BUILTIN
export KBUILD_CHECKSRC KBUILD_SRC KBUILD_EXTMOD

# Beautify output
# ---------------------------------------------------------------------------
#
# Normally, we echo the whole command before executing it. By making
# that echo $($(quiet)$(cmd)), we now have the possibility to set
# $(quiet) to choose other forms of output instead, e.g.
#
#         quiet_cmd_cc_o_c = Compiling $(RELDIR)/$@
#         cmd_cc_o_c       = $(CC) $(c_flags) -c -o $@ $<
#
# If $(quiet) is empty, the whole command will be printed.
# If it is set to "quiet_", only the short version will be printed.
# If it is set to "silent_", nothing wil be printed at all, since
# the variable $(silent_cmd_cc_o_c) doesn't exist.
#
# A simple variant is to prefix commands with $(Q) - that's useful
# for commands that shall be hidden in non-verbose mode.
#
#	$(Q)ln $@ :<
#
# If KBUILD_VERBOSE equals 0 then the above command will be hidden.
# If KBUILD_VERBOSE equals 1 then the above command is displayed.

ifeq ($(KBUILD_VERBOSE),1)
  quiet =
  Q =
else
  quiet=quiet_
  Q = @
endif

# If the user is running make -s (silent mode), suppress echoing of
# commands

ifneq ($(findstring s,$(MAKEFLAGS)),)
  quiet=silent_
endif

export quiet Q KBUILD_VERBOSE


# Look for make include files relative to root of kernel src
MAKEFLAGS += --include-dir=$(srctree)

# We need some generic definitions
include $(srctree)/scripts/Kbuild.include

# For maximum performance (+ possibly random breakage, uncomment
# the following)

MAKEFLAGS += -rR

# Make variables (CC, etc...)

AS		= $(CROSS_COMPILE)as
CC		= $(CROSS_COMPILE)gcc
LD		= $(CC) -nostdlib
CPP		= $(CC) -E
AR		= $(CROSS_COMPILE)ar
NM		= $(CROSS_COMPILE)nm
STRIP		= $(CROSS_COMPILE)strip
OBJCOPY		= $(CROSS_COMPILE)objcopy
OBJDUMP		= $(CROSS_COMPILE)objdump
AWK		= awk
GENKSYMS	= scripts/genksyms/genksyms
DEPMOD		= /sbin/depmod
KALLSYMS	= scripts/kallsyms
PERL		= perl
CHECK		= sparse

CHECKFLAGS     := -D__linux__ -Dlinux -D__STDC__ -Dunix -D__unix__ -Wbitwise $(CF)
MODFLAGS	= -DMODULE
CFLAGS_MODULE   = $(MODFLAGS)
AFLAGS_MODULE   = $(MODFLAGS)
LDFLAGS_MODULE  = -r
CFLAGS_KERNEL	=
AFLAGS_KERNEL	=


# Use LINUXINCLUDE when you must reference the include/ directory.
# Needed to be compatible with the O= option
CFLAGS		:=
CPPFLAGS	:=
AFLAGS		:=

# Read KERNELRELEASE from .kernelrelease (if it exists)
KERNELRELEASE = $(shell cat .kernelrelease 2> /dev/null)
KERNELVERSION = $(VERSION).$(PATCHLEVEL).$(SUBLEVEL)$(EXTRAVERSION)

export	VERSION PATCHLEVEL SUBLEVEL KERNELRELEASE KERNELVERSION \
	ARCH CONFIG_SHELL HOSTCC HOSTCFLAGS CROSS_COMPILE AS LD CC \
	CPP AR NM STRIP OBJCOPY OBJDUMP MAKE AWK GENKSYMS PERL UTS_MACHINE \
	HOSTCXX HOSTCXXFLAGS LDFLAGS_MODULE CHECK CHECKFLAGS

export CPPFLAGS NOSTDINC_FLAGS LINUXINCLUDE OBJCOPYFLAGS LDFLAGS
export CFLAGS CFLAGS_KERNEL CFLAGS_MODULE
export AFLAGS AFLAGS_KERNEL AFLAGS_MODULE

# When compiling out-of-tree modules, put MODVERDIR in the module
# tree rather than in the kernel tree. The kernel tree might
# even be read-only.
export MODVERDIR := $(if $(KBUILD_EXTMOD),$(firstword $(KBUILD_EXTMOD))/).tmp_versions

# Files to ignore in find ... statements

RCS_FIND_IGNORE := \( -name SCCS -o -name BitKeeper -o -name .svn -o -name CVS -o -name .pc -o -name .hg -o -name .git \) -prune -o
export RCS_TAR_IGNORE := --exclude SCCS --exclude BitKeeper --exclude .svn --exclude CVS --exclude .pc --exclude .hg --exclude .git

# ===========================================================================
# Rules shared between *config targets and build targets

# Basic helpers built in scripts/
PHONY += scripts_basic
scripts_basic:
	$(Q)$(MAKE) $(build)=scripts/basic

# To avoid any implicit rule to kick in, define an empty command.
scripts/basic/%: scripts_basic ;

PHONY += outputmakefile
# outputmakefile generates a Makefile in the output directory, if using a
# separate output directory. This allows convenient use of make in the
# output directory.
outputmakefile:
ifneq ($(KBUILD_SRC),)
	$(Q)$(CONFIG_SHELL) $(srctree)/scripts/mkmakefile \
	    $(srctree) $(objtree) $(VERSION) $(PATCHLEVEL)
endif

# To make sure we do not include .config for any of the *config targets
# catch them early, and hand them over to scripts/kconfig/Makefile
# It is allowed to specify more targets when calling make, including
# mixing *config targets and build targets.
# For example 'make oldconfig all'.
# Detect when mixed targets is specified, and make a second invocation
# of make so .config is not included in this case either (for *config).

no-dot-config-targets := clean mrproper distclean \
			 cscope TAGS tags help %docs check%

config-targets := 0
mixed-targets  := 0
dot-config     := 1

ifneq ($(filter $(no-dot-config-targets), $(MAKECMDGOALS)),)
	ifeq ($(filter-out $(no-dot-config-targets), $(MAKECMDGOALS)),)
		dot-config := 0
	endif
endif

ifeq ($(KBUILD_EXTMOD),)
        ifneq ($(filter config %config,$(MAKECMDGOALS)),)
                config-targets := 1
                ifneq ($(filter-out config %config,$(MAKECMDGOALS)),)
                        mixed-targets := 1
                endif
        endif
endif

ifeq ($(mixed-targets),1)
# ===========================================================================

## busybox 1.10.2

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 VERSION = 1
-PATCHLEVEL = 4
-SUBLEVEL = 1
+PATCHLEVEL = 10
+SUBLEVEL = 2
 EXTRAVERSION =
 NAME = Unnamed
 
@@ -183,11 +183,6 @@
 	  else if [ -x /bin/bash ]; then echo /bin/bash; \
 	  else echo sh; fi ; fi)
 
-HOSTCC  	= gcc
-HOSTCXX  	= g++
-HOSTCFLAGS	= -Wall -Wstrict-prototypes -O2 -fomit-frame-pointer
-HOSTCXXFLAGS	= -O2
-
 # 	Decide whether to build built-in, modular, or both.
 #	Normally, just do built-in.
 
@@ -262,8 +257,15 @@
 # Look for make include files relative to root of kernel src
 MAKEFLAGS += --include-dir=$(srctree)
 
+HOSTCC  	= gcc
+HOSTCXX  	= g++
+HOSTCFLAGS	:=
+HOSTCXXFLAGS	:=
 # We need some generic definitions
 include $(srctree)/scripts/Kbuild.include
+
+HOSTCFLAGS	+= $(call hostcc-option,-Wall -Wstrict-prototypes -O2 -fomit-frame-pointer,)
+HOSTCXXFLAGS	+= -O2
 
 # For maximum performance (+ possibly random breakage, uncomment
 # the following)
@@ -299,9 +301,11 @@
 
 # Use LINUXINCLUDE when you must reference the include/ directory.
 # Needed to be compatible with the O= option
-CFLAGS		:=
-CPPFLAGS	:=
-AFLAGS		:=
+CFLAGS		:= $(CFLAGS)
+CPPFLAGS	:= $(CPPFLAGS)
+AFLAGS		:= $(AFLAGS)
+LDFLAGS		:= $(LDFLAGS)
+LDLIBS		:=
 
 # Read KERNELRELEASE from .kernelrelease (if it exists)
 KERNELRELEASE = $(shell cat .kernelrelease 2> /dev/null)
@@ -315,6 +319,7 @@
 export CPPFLAGS NOSTDINC_FLAGS LINUXINCLUDE OBJCOPYFLAGS LDFLAGS
 export CFLAGS CFLAGS_KERNEL CFLAGS_MODULE
 export AFLAGS AFLAGS_KERNEL AFLAGS_MODULE
+export FLTFLAGS
 
 # When compiling out-of-tree modules, put MODVERDIR in the module
 # tree rather than in the kernel tree. The kernel tree might
@@ -373,9 +378,3 @@
                 config-targets := 1
                 ifneq ($(filter-out config %config,$(MAKECMDGOALS)),)
                         mixed-targets := 1
-                endif
-        endif
-endif
-
-ifeq ($(mixed-targets),1)
-# ===========================================================================

## busybox 1.13.3

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 VERSION = 1
-PATCHLEVEL = 10
-SUBLEVEL = 2
+PATCHLEVEL = 13
+SUBLEVEL = 3
 EXTRAVERSION =
 NAME = Unnamed
 
@@ -141,17 +141,6 @@
 
 export srctree objtree VPATH TOPDIR
 
-
-# SUBARCH tells the usermode build what the underlying arch is.  That is set
-# first, and if a usermode build is happening, the "ARCH=um" on the command
-# line overrides the setting of ARCH below.  If a native build is happening,
-# then ARCH is assigned, getting whatever value it gets normally, and
-# SUBARCH is subsequently ignored.
-
-SUBARCH := $(shell uname -m | sed -e s/i.86/i386/ -e s/sun4u/sparc64/ \
-				  -e s/arm.*/arm/ -e s/sa110/arm/ \
-				  -e s/s390x/s390/ -e s/parisc64/parisc/ \
-				  -e s/ppc.*/powerpc/ -e s/mips.*/mips/ )
 
 # Cross compiling and selecting different set of gcc/bin-utils
 # ---------------------------------------------------------------------------
@@ -172,8 +161,32 @@
 # Default value for CROSS_COMPILE is not to prefix executables
 # Note: Some architectures assign CROSS_COMPILE in their arch/*/Makefile
 
-ARCH		?= $(SUBARCH)
-CROSS_COMPILE	?=
+CROSS_COMPILE ?=
+# bbox: we may have CONFIG_CROSS_COMPILER_PREFIX in .config,
+# and it has not been included yet... thus using an awkward syntax.
+ifeq ($(CROSS_COMPILE),)
+CROSS_COMPILE := $(shell grep ^CONFIG_CROSS_COMPILER_PREFIX .config 2>/dev/null)
+CROSS_COMPILE := $(subst CONFIG_CROSS_COMPILER_PREFIX=,,$(CROSS_COMPILE))
+CROSS_COMPILE := $(subst ",,$(CROSS_COMPILE))
+endif
+
+# SUBARCH tells the usermode build what the underlying arch is.  That is set
+# first, and if a usermode build is happening, the "ARCH=um" on the command
+# line overrides the setting of ARCH below.  If a native build is happening,
+# then ARCH is assigned, getting whatever value it gets normally, and
+# SUBARCH is subsequently ignored.
+
+ifneq ($(CROSS_COMPILE),)
+SUBARCH := $(shell echo $(CROSS_COMPILE) | cut -d- -f1)
+else
+SUBARCH := $(shell uname -m)
+endif
+SUBARCH := $(shell echo $(SUBARCH) | sed -e s/i.86/i386/ -e s/sun4u/sparc64/ \
+					 -e s/arm.*/arm/ -e s/sa110/arm/ \
+					 -e s/s390x/s390/ -e s/parisc64/parisc/ \
+					 -e s/ppc.*/powerpc/ -e s/mips.*/mips/ )
+
+ARCH ?= $(SUBARCH)
 
 # Architecture as present in compile.h
 UTS_MACHINE := $(ARCH)
@@ -302,6 +315,8 @@
 # Use LINUXINCLUDE when you must reference the include/ directory.
 # Needed to be compatible with the O= option
 CFLAGS		:= $(CFLAGS)
+# Added only to final link stage of busybox binary
+CFLAGS_busybox	:= $(CFLAGS_busybox)
 CPPFLAGS	:= $(CPPFLAGS)
 AFLAGS		:= $(AFLAGS)
 LDFLAGS		:= $(LDFLAGS)
@@ -358,23 +373,3 @@
 # mixing *config targets and build targets.
 # For example 'make oldconfig all'.
 # Detect when mixed targets is specified, and make a second invocation
-# of make so .config is not included in this case either (for *config).
-
-no-dot-config-targets := clean mrproper distclean \
-			 cscope TAGS tags help %docs check%
-
-config-targets := 0
-mixed-targets  := 0
-dot-config     := 1
-
-ifneq ($(filter $(no-dot-config-targets), $(MAKECMDGOALS)),)
-	ifeq ($(filter-out $(no-dot-config-targets), $(MAKECMDGOALS)),)
-		dot-config := 0
-	endif
-endif
-
-ifeq ($(KBUILD_EXTMOD),)
-        ifneq ($(filter config %config,$(MAKECMDGOALS)),)
-                config-targets := 1
-                ifneq ($(filter-out config %config,$(MAKECMDGOALS)),)
-                        mixed-targets := 1

## busybox 1.15.3

=== debian/changelog ===
busybox (1:1.15.3-1ubuntu5) maverick; urgency=low

  * applets-fallback.patch: Never execute busybox applets when chrooting
    (LP: #594162).

 -- Colin Watson <cjwatson@ubuntu.com>  Mon, 04 Oct 2010 16:06:06 +0100

busybox (1:1.15.3-1ubuntu4) maverick; urgency=low

  * Add cross-compiling support (LP: #623392).

 -- Colin Watson <cjwatson@ubuntu.com>  Wed, 25 Aug 2010 23:36:38 +0100

busybox (1:1.15.3-1ubuntu3) maverick; urgency=low

  * while armel builds without -marm it does not seem to run properly (things
    like "reboot -f" in initramfs just hang silently), re-enable -marm for now

 -- Oliver Grawert <ogra@ubuntu.com>  Wed, 25 Aug 2010 18:05:23 +0200

busybox (1:1.15.3-1ubuntu2) maverick; urgency=low

  * armel seems to build fine without -marm nowadays, so remove it.
  * grep-o-loop.patch: Fix infinite loop in 'grep -o' with a pattern that
    matches the zero-length string at the start of the line (LP: #619817).

 -- Colin Watson <cjwatson@ubuntu.com>  Thu, 19 Aug 2010 15:16:46 +0100

busybox (1:1.15.3-1ubuntu1) maverick; urgency=low

  * Resynchronise with Debian (LP: #566845).  Remaining changes:
    - [udeb] Enable chvt, dd conv=notrunc, getopt (and -l), killall,
      losetup, mktemp, NFS mount, od, ping, stat, and remote syslog.
    - [deb] Enable mdev.
    - [deb, static] Enable fractional sleep.
    - Enable 'mount -f' and mount helpers for all targets.
    - Add busybox-initramfs.
    - test-bin.patch: Move test and friends to /bin.
    - Add static-sh alias name for ash, and install /bin/static-sh symlink to
      busybox in busybox-static.
    - Use -marm on armel due to gcc thumb2 compilation issue.
    - rmescapes-stack.patch: Refresh stack pointers after makestrspace in
      _rmescapes.

 -- Colin Watson <cjwatson@ubuntu.com>  Wed, 07 Jul 2010 17:52:24 +0100

busybox (1:1.13.3-1ubuntu11) lucid; urgency=low

  * rmescapes-stack.patch: Refresh stack pointers after makestrspace in
    _rmescapes (backported from dash, although I reinvented it independently
    too; LP: #567345).

 -- Colin Watson <cjwatson@ubuntu.com>  Thu, 22 Apr 2010 14:15:15 +0100

busybox (1:1.13.3-1ubuntu10) lucid; urgency=low

  * Rebuild statically linked binary against recent libc.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 18 Apr 2010 22:26:24 +0000

busybox (1:1.13.3-1ubuntu9) lucid; urgency=low

  * Using -marm due to gcc thumb2 compile issue (LP: #511197)
  * Small policy cleanup of control file to make lintian happier

 -- David Sugar <david.sugar@canonical.com>  Fri, 22 Jan 2010 08:03:07 -0500

busybox (1:1.13.3-1ubuntu8) lucid; urgency=low

  * add static-sh alias name for ash and install
    /bin/static-sh symlink busybox in busybox-static (LP: #505887)

 -- Michael Vogt <michael.vogt@ubuntu.com>  Mon, 11 Jan 2010 13:43:24 +0100

busybox (1:1.13.3-1ubuntu7) karmic; urgency=low

  * [initramfs] Enable df, for casper (LP: #424731).

 -- Colin Watson <cjwatson@ubuntu.com>  Mon, 07 Sep 2009 15:40:02 +0100

busybox (1:1.13.3-1ubuntu6) karmic; urgency=low

  * [initramfs] Enable CONFIG_FEATURE_USE_TERMIOS (LP: #268306).
  * [initramfs] Enable du, for casper (LP: #424731).

 -- Colin Watson <cjwatson@ubuntu.com>  Mon, 07 Sep 2009 12:46:29 +0100

busybox (1:1.13.3-1ubuntu5) karmic; urgency=low

  * [initramfs] Enable gunzip and gzip (LP: #392218). (gzip is overkill in
    most respects, but is needed to make the 'gzip' command visible for the
    benefit of kbd.)

 -- Colin Watson <cjwatson@ubuntu.com>  Mon, 03 Aug 2009 10:54:02 +0100

busybox (1:1.13.3-1ubuntu4) karmic; urgency=low

  * printf-errors.patch (update): Set errno to zero on entry to print_direc,
    as otherwise %c and %s return undefined exit codes.

 -- Colin Watson <cjwatson@ubuntu.com>  Thu, 25 Jun 2009 18:12:34 +0100

busybox (1:1.13.3-1ubuntu3) karmic; urgency=high

  * [deb, initramfs, static] Enable fractional sleep (thanks, Jean-Louis
    Dupond; LP: #391299).

 -- Colin Watson <cjwatson@ubuntu.com>  Wed, 24 Jun 2009 09:02:31 +0100

busybox (1:1.13.3-1ubuntu2) karmic; urgency=low

  * [initramfs] Link dynamically rather than statically. We always have
    glibc in the initramfs these days.

 -- Colin Watson <cjwatson@ubuntu.com>  Tue, 23 Jun 2009 10:02:27 +0100

busybox (1:1.13.3-1ubuntu1) karmic; urgency=low

  * Resynchronise with Debian. Remaining changes:
    - [udeb] Enable chvt, dd conv=notrunc, getopt (and -l), killall,
      losetup, mktemp, NFS mount, od, ping, stat, and remote syslog.
    - [deb] Enable mdev.
    - Enable 'mount -f' and mount helpers for all targets.
    - Add busybox-initramfs.
    - mkswap-uuid.patch: Set UUIDs on swap areas.
    - test-bin.patch: Move test and friends to /bin.
    - mount-helper-fixes.patch: Add proper support for mount -i (don't use
      external mount helper), and trivial support for umount -i although
      busybox umount doesn't support external helpers yet. Fix handling of
      mount -f and -n.
    - getopt-long-only.patch: Allow 'getopt -l' to be enabled independently
      of the whole of CONFIG_GETOPT_LONG, so that it can be enabled more
      cheaply.
    - printf-errors.patch: Exit non-zero on conversion errors.
  * procps-kernel-threads.patch: Drop. We haven't needed this since we
    rewrote casper as an initramfs-tools module anyway, and the bit of this
    patch that actually does anything was dropped in 1:1.01-4ubuntu1 so we
    clearly don't need the rest of it!
  * [initramfs] Include wc for the benefit of live-initramfs (LP: #387944).

 -- Colin Watson <cjwatson@ubuntu.com>  Fri, 19 Jun 2009 11:41:15 +0100

busybox (1:1.10.2-2ubuntu7) jaunty; urgency=low

  * no-byte-swap-compressed-help.patch: Backport r23074 from upstream to fix
    segfaults on big-endian machines (spotted by Wartan Hachaturow).

 -- Colin Watson <cjwatson@ubuntu.com>  Fri, 27 Mar 2009 15:23:29 +0000

busybox (1:1.10.2-2ubuntu6) jaunty; urgency=low

  * [udeb] Enable FEATURE_DD_IBS_OBS, so that we can use conv=notrunc while
    restoring swap UUIDs (LP: #336992).



=== debian/control ===
Source: busybox
Priority: optional
Section: utils
Maintainer: Ubuntu Core Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Install System Team <debian-boot@lists.debian.org>
Uploaders: Bastian Blank <waldi@debian.org>
Build-Depends: debhelper (>> 7), lsb-release, quilt
Standards-Version: 3.7.3

Package: busybox
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: busybox-static
Replaces: busybox-static
Description: Tiny utilities for small and embedded systems
 BusyBox combines tiny versions of many common UNIX utilities into a single
 small executable. It provides minimalist replacements for the most common
 utilities you would usually find on your desktop system (i.e., ls, cp, mv,
 mount, tar, etc.). The utilities in BusyBox generally have fewer options than
 their full-featured GNU cousins; however, the options that are included
 provide the expected functionality and behave very much like their GNU
 counterparts.
 .
 This package installs the BusyBox binary but does not install
 symlinks for any of the supported utilities. Some of the utilities
 can be used in the system by installing the busybox-syslogd,
 busybox-udhcpc or busybox-udhcpd packages. You can also use
 /bin/busybox --install to install BusyBox to the current directory
 (but you do not want to do this in / on your Debian system!)

Package: busybox-static
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: busybox
Replaces: busybox
Priority: extra
Section: shells
Description: Standalone rescue shell with tons of builtin utilities
 BusyBox combines tiny versions of many common UNIX utilities into a single
 small executable. It provides minimalist replacements for the most common
 utilities you would usually find on your desktop system (i.e., ls, cp, mv,
 mount, tar, etc.).  The utilities in BusyBox generally have fewer options than
 their full-featured GNU cousins; however, the options that are included
 provide the expected functionality and behave very much like their GNU
 counterparts.
 .
 busybox-static provides you with a statically linked simple stand alone shell
 that provides all the utilities available in BusyBox. This package is
 intended to be used as a rescue shell, in the event that you screw up your
 system. Invoke "busybox sh" and you have a standalone shell ready to save
 your system from certain destruction. Invoke "busybox", and it will list the
 available builtin commands.

Package: busybox-initramfs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: busybox-cvs-initramfs
Replaces: busybox-cvs-initramfs
Section: shells
Description: Standalone shell setup for initramfs
 BusyBox combines tiny versions of many common UNIX utilities into a single
 small executable. It provides minimalist replacements for the most common
 utilities you would usually find on your desktop system (i.e., ls, cp, mv,
 mount, tar, etc.). The utilities in BusyBox generally have fewer options than
 their full-featured GNU cousins; however, the options that are included
 provide the expected functionality and behave very much like their GNU
 counterparts.
 .
 busybox-initramfs provides a statically linked simple stand alone shell
 that provides only the basic utilities needed for the initramfs.

Package: busybox-udeb
XC-Package-Type: udeb
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Section: debian-installer
Priority: extra
Description: Tiny utilities for the debian-installer
 BusyBox combines tiny versions of many common UNIX utilities into a single
 small executable. It provides minimalist replacements for the most common
 utilities you would usually find on your desktop system (i.e., ls, cp, mv,
 mount, tar, etc.). The utilities in BusyBox generally have fewer options than
 their full-featured GNU cousins; however, the options that are included
 provide the expected functionality and behave very much like their GNU
 counterparts.
 .
 busybox-cvs-udeb is used by the debian-installer, so unless you are working on
 the debian-installer, this package is not for you. Installing this 
 on your Debian system is a very, very bad idea. You have been warned.

Package: busybox-syslogd
Architecture: all
Depends: busybox (>= ${source:Version}) | busybox-static (>= ${source:Version}), ${misc:Depends}
Provides: linux-kernel-log-daemon, system-log-daemon, klogd, syslogd
Replaces: sysklogd, klogd, inetutils-syslogd
Conflicts: klogd, syslogd, sysklogd, linux-kernel-log-daemon, system-log-daemon
Description: Provides syslogd and klogd using busybox
 The system log daemon is responsible for providing logging of
 messages received from programs and facilities on the local host as
 well as from remote hosts.
 .
 The kernel log daemon listens to kernel message sources and is
 responsible for prioritizing and processing operating system
 messages.
 .
 The busybox implementation of the syslogd is particular useful on
 embedded, diskless (netboot) or flash disk based systems because it
 can use a fixed size ring buffer for logging instead of saving logs
 to the disk or sending it to remote logging servers. The ring buffer
 can be read using the (also busybox based) command logread.
 .
 This package provides the glue to the busybox syslogd and klogd to be
 used in the system by providing the appropriate symbolic links and
 scripts.

Package: udhcpc
Architecture: all
Depends: busybox (>= ${source:Version}) | busybox-static (>= ${source:Version}), ${misc:Depends}
Description: Provides the busybox DHCP client implementation
 Busybox contains a very small yet fully function RFC compliant DHCP
 client formerly known as udhcpc.
 .
 This package contains the glue to use the busybox udhcpc as DHCP
 client in the system by providing the appropriate symbolic links and
 scripts.

Package: udhcpd
Architecture: all
Depends: busybox (>= ${source:Version}) | busybox-static (>= ${source:Version}), ${misc:Depends}
Provides: dhcpd
Description: Provides the busybox DHCP server implementation
 Busybox contains a very small yet fully function RFC compliant DHCP
 server formerly known as udhcpd.
 .
 This package contains the glue to use the busybox udhcpd as DHCP
 server in the system by providing the appropriate symbolic links and
 scripts.

=== debian/rules ===
#!/usr/bin/make -f

SHELL := sh -e
DEB_HOST_ARCH := $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_BUILD_ARCH := $(shell dpkg-architecture -qDEB_BUILD_ARCH)
DEB_HOST_GNU_TYPE := $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE := $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
SOURCE := $(shell dpkg-parsechangelog | sed -ne 's,^Source: *\(.*\)$$,\1,p')
VERSION_DEBIAN := $(shell dpkg-parsechangelog | sed -ne 's,^Version: *\(.*\)$$,\1,p')
VERSION := $(shell echo "$(VERSION_DEBIAN)" | sed -e 's,^[^:]*:,,' -e 's,-[^-]*$$,,')
 
BUILD_DIR = debian/build
STAMPS_DIR = debian/stamps

ifeq ($(DEB_BUILD_ARCH),armel)
        CFLAGS += -marm
endif

ifeq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
CROSS :=
else
CROSS := CROSS_COMPILE=$(DEB_HOST_GNU_TYPE)-
endif

patch: $(STAMPS_DIR)/patch

$(STAMPS_DIR)/patch:
	dh_testdir
	@mkdir -p $(STAMPS_DIR)
	QUILT_PATCHES=$(CURDIR)/debian/patches quilt --quiltrc /dev/null push -a || test $$? = 2
	touch $@

setup: $(STAMPS_DIR)/setup_deb $(STAMPS_DIR)/setup_static $(STAMPS_DIR)/setup_udeb $(STAMPS_DIR)/setup_initramfs

$(STAMPS_DIR)/setup_%: SOURCE_FILES = $(filter-out debian, $(wildcard * .[^.]*))
$(STAMPS_DIR)/setup_%: DIR=$(BUILD_DIR)/build_$*
$(STAMPS_DIR)/setup_%: $(STAMPS_DIR)/patch
	dh_testdir
	rm -rf '$(DIR)'
	mkdir -p '$(DIR)'
	cp -a $(SOURCE_FILES) '$(DIR)'
	cp debian/config/$* '$(DIR)'/.config
	$(MAKE) -C '$(DIR)' oldconfig
	touch $@

build: $(STAMPS_DIR)/build_deb $(STAMPS_DIR)/build_static $(STAMPS_DIR)/build_udeb $(STAMPS_DIR)/build_initramfs

$(STAMPS_DIR)/build_%: DIR=$(BUILD_DIR)/build_$*
$(STAMPS_DIR)/build_%: $(STAMPS_DIR)/setup_%
	dh_testdir
	$(MAKE) -C '$(DIR)' install docs/busybox.1 BB_EXTRA_VERSION="$(shell lsb_release -is) $(VERSION_DEBIAN)" $(CROSS)
	touch $@

$(STAMPS_DIR)/indepbuild_%: DIR=$(BUILD_DIR)/indepbuild_$*
$(STAMPS_DIR)/indepbuild_%: 
	dh_testdir
	touch $@

$(BUILD_DIR) $(STAMPS_DIR):
	@[ -d $@ ] || mkdir $@

maintainerclean:
	rm -rf $(filter-out .svn debian, $(wildcard * .[^.]*))

clean:
	dh_testdir
	rm -rf $(BUILD_DIR) $(STAMPS_DIR)
	dh_clean

binary-indep: binary-indep_busybox-syslogd binary-indep_udhcpc binary-indep_udhcpd

binary-arch: binary-arch_busybox binary-arch_busybox-static binary-arch_busybox-udeb binary-arch_busybox-initramfs

binary-arch_busybox: DIR = $(BUILD_DIR)/build_deb
binary-arch_busybox: export DH_OPTIONS = -pbusybox
binary-arch_busybox: $(STAMPS_DIR)/build_deb
	dh_testdir
	dh_testroot
	dh_prep
	dh_install -X.svn --sourcedir=$(DIR)
	@$(MAKE) -f debian/rules binary-arch_all

binary-arch_busybox-static: DIR = $(BUILD_DIR)/build_static
binary-arch_busybox-static: export DH_OPTIONS = -pbusybox-static
binary-arch_busybox-static: $(STAMPS_DIR)/build_static
	dh_testdir
	dh_testroot
	dh_prep
	dh_install -X.svn --sourcedir=$(DIR)
	@$(MAKE) -f debian/rules binary-arch_all

binary-arch_busybox-udeb: DIR = $(BUILD_DIR)/build_udeb
binary-arch_busybox-udeb: export DH_OPTIONS = -pbusybox-udeb
binary-arch_busybox-udeb: $(STAMPS_DIR)/build_udeb
	dh_testdir
	dh_testroot
	dh_prep
	# Remove init link, but init support is still compiled in to be
	# used.
	rm -f $(DIR)/_install/sbin/init
	dh_install -X.svn --sourcedir=$(DIR)
	@$(MAKE) -f debian/rules binary-arch_all

binary-arch_busybox-initramfs: DIR = $(BUILD_DIR)/build_initramfs
binary-arch_busybox-initramfs: export DH_OPTIONS = -pbusybox-initramfs
binary-arch_busybox-initramfs: $(STAMPS_DIR)/build_initramfs
	dh_testdir
	dh_testroot
	dh_prep
	dh_install -X.svn --sourcedir=$(DIR)
	@$(MAKE) -f debian/rules binary-arch_all

binary-arch_all:
	dh_installdirs
	dh_installdocs
	dh_installchangelogs
	dh_strip
	dh_link
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary-indep_busybox-syslogd: export DH_OPTIONS = -pbusybox-syslogd
binary-indep_busybox-syslogd:
	dh_testdir
	dh_testroot
	dh_prep
	dh_link
	dh_installinit -u"defaults 10 90"
	dh_installinit -u"defaults 11 89" --name=busybox-klogd
	$(MAKE) -f debian/rules binary-indep_all

binary-indep_udhcpc: export DH_OPTIONS = -pudhcpc
binary-indep_udhcpc:
	dh_testdir
	dh_testroot
	dh_prep
	dh_link
	dh_install -X.svn
	$(MAKE) -f debian/rules binary-indep_all

binary-indep_udhcpd: export DH_OPTIONS = -pudhcpd
binary-indep_udhcpd:
	dh_testdir
	dh_testroot
	dh_prep
	dh_link
	dh_installinit --onlyscripts
	dh_install -X.svn
	$(MAKE) -f debian/rules binary-indep_all

binary-indep_all:
	dh_installdirs
	dh_installdocs
	dh_installchangelogs
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch

DIR_ORIG = ../orig/$(SOURCE)-$(VERSION)
TAR_ORIG_NAME = $(SOURCE)_$(VERSION).orig.tar.bz2
TAR_ORIG = $(firstword $(wildcard ../$(TAR_ORIG_NAME)) $(wildcard ../orig/$(TAR_ORIG_NAME)))

orig: $(DIR_ORIG)
	rsync --delete --exclude debian --exclude .svk --exclude .svn --link-dest=$(DIR_ORIG)/ -a $(DIR_ORIG)/ .

$(DIR_ORIG):
ifeq ($(TAR_ORIG),)
	$(error Cannot find orig tarball $(TAR_ORIG_NAME))
else
	mkdir -p ../orig
	tar -C ../orig -xjf $(TAR_ORIG)
endif
